Subject: Re: bug#47218: glibc 2.33's HWCAPS and GCC Function Multiversioning for performance

From: Ludovic Courtès <[email-masked]>
Date: Thu, 18 Mar 2021 14:17:42 +0100

Hi Léo,

Léo Le Bouter <[email-masked]> skribis:

> Please see:
> - 
> https://www.gnu.org/software/libc/manual/html_mono/libc.html#Hardware-Capability-Tunables
> - https://www.phoronix.com/scan.php?page=news_item&px=glibc-hwcaps-RFC
> - https://gcc.gnu.org/onlinedocs/gcc/Function-Multiversioning.html
>
> This could help GNU Guix create binaries that include multiple code
> paths for several CPU features in the same binary and selecting the
> best at runtime when the binary is run.
>
> It is the best fit for GNU Guix because it means we can still use
> substitutes and profit from specialized optimizations without
> parameterized packages or each user adding "-march=native" to CFLAGS
> (breaking reproducibility).

For the record, we are well aware of these features and follow this very
closely in particular in the context of Guix-HPC:

  https://hpc.guix.info/blog/2018/01/pre-built-binaries-vs-performance/

It seems to me that this bug report is not actionable though.  Unless
there are concrete steps you’d like to suggest, I propose to close this
issue.

Thanks,
Ludo’.